%{?nodejs_find_provides_and_requires}

#enable/disable tests in case the deps aren't there
%bcond_with tests

%define oname uglify-js

Name:           uglify-js3
Version:        3.18.0
Release:        1%{?dist}
Summary:        JavaScript parser, mangler/compressor and beautifier toolkit
License:        BSD-2-Clause
URL:            https://github.com/mishoo/UglifyJS
Source0:        https://registry.npmjs.org/%{oname}/-/%{oname}-%{version}.tgz

BuildArch:      noarch
ExclusiveArch:  %{nodejs_arches} noarch

Provides:       nodejs-uglify-js3 = %{version}-%{release}

BuildRequires:  nodejs
BuildRequires:  nodejs-packaging
BuildRequires:  web-assets-devel

%if %{with tests}
BuildRequires:  npm(acorn)
BuildRequires:  npm(semver)
%endif

Requires:       js-uglify3 = %{version}-%{release}

%description
JavaScript parser, mangler/compressor and beautifier toolkit.

This package ships the uglifyjs command-line tool and a library suitable for
use within Node.js.

%package -n js-uglify3
Summary:        JavaScript parser, mangler/compressor and beautifier toolkit - core library

Requires:       web-assets-filesystem

%description -n js-uglify3
JavaScript parser, mangler/compressor and beautifier toolkit.

This package ships a JavaScript library suitable for use by any JavaScript
runtime.

%prep
%autosetup -n package

chmod 0755 bin/uglifyjs

%build
#nothing to do


%install
mkdir -p %{buildroot}%{_jsdir}/%{oname}-3
cp -pr lib/* %{buildroot}%{_jsdir}/%{oname}-3

mkdir -p %{buildroot}%{nodejs_sitelib}/uglify-js@3
cp -pr bin tools package.json %{buildroot}%{nodejs_sitelib}/uglify-js@3
ln -rs %{buildroot}%{_jsdir}/%{oname}-3 \
       %{buildroot}%{nodejs_sitelib}/uglify-js@3/lib
# Fix for rpmlint.
sed -i -e 's|^#! */usr/bin/env node|#!/usr/bin/node|' \
  %{buildroot}%{nodejs_sitelib}/uglify-js@3/bin/uglifyjs
chmod 755 %{buildroot}%{nodejs_sitelib}/uglify-js@3/bin/uglifyjs

mkdir -p %{buildroot}%{_bindir}
ln -rs %{buildroot}%{nodejs_sitelib}/uglify-js@3/bin/uglifyjs \
       %{buildroot}%{_bindir}/uglifyjs-3

%nodejs_symlink_deps


%check
%nodejs_symlink_deps --check
%{__nodejs} -e 'require("./")'
%if %{with tests}
# Prevent timeout error on an ARM builder which is slower than the x86 builder.
sed -i '/timeout/ s/5000/10000/' test/mocha/cli.js
sed -i '/timeout/ s/10000/20000/' test/mocha/let.js
sed -i '/timeout/ s/20000/40000/' test/mocha/spidermonkey.js
NODE_DISABLE_COLORS=true %{__nodejs} test/run-tests.js
%endif


%files
%{nodejs_sitelib}/uglify-js@3
%{_bindir}/uglifyjs-3


%files -n js-uglify3
%{_jsdir}/%{oname}-3
%doc README.md
%license LICENSE


%changelog
* Mon Jun 10 2024 Mattias Ellert <mattias.ellert@physics.uu.se> - 3.18.0-1
- Update to 3.18.0

* Wed Mar 15 2023 Mattias Ellert <mattias.ellert@physics.uu.se> - 3.17.4-1
- Update to 3.17.4

* Tue Sep 20 2022 Mattias Ellert <mattias.ellert@physics.uu.se> - 3.17.1-1
- Update to 3.17.1

* Fri Jun 17 2022 Mattias Ellert <mattias.ellert@physics.uu.se> - 3.16.1-1
- Update to 3.16.1

* Wed Apr 20 2022 Mattias Ellert <mattias.ellert@physics.uu.se> - 3.15.4-1
- Update to 3.15.4

* Sun Mar 20 2022 Mattias Ellert <mattias.ellert@physics.uu.se> - 3.15.3-1
- Update to 3.15.3

* Mon Feb 28 2022 Mattias Ellert <mattias.ellert@physics.uu.se> - 3.15.2-1
- Update to 3.15.2

* Mon Feb 07 2022 Mattias Ellert <mattias.ellert@physics.uu.se> - 3.15.1-1
- Update to 3.15.1

* Wed Jan 26 2022 Mattias Ellert <mattias.ellert@physics.uu.se> - 3.15.0-1
- Update to 3.15.0

* Thu Dec 16 2021 Mattias Ellert <mattias.ellert@physics.uu.se> - 3.14.5-1
- Update to 3.14.5

* Wed Dec 01 2021 Mattias Ellert <mattias.ellert@physics.uu.se> - 3.14.4-1
- Update to 3.14.4

* Tue Nov 02 2021 Mattias Ellert <mattias.ellert@physics.uu.se> - 3.14.3-1
- Update to 3.14.3

* Thu Oct 14 2021 Mattias Ellert <mattias.ellert@physics.uu.se> - 3.14.2-1
- Update to 3.14.2

* Mon Aug 16 2021 Mattias Ellert <mattias.ellert@physics.uu.se> - 3.14.1-1
- Parallel installable uglify-js version 3 for EPEL
